package org.bonitasoft.support.command;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

import org.bonitasoft.engine.command.SCommandExecutionException;
import org.bonitasoft.engine.command.SCommandParameterizationException;
import org.bonitasoft.engine.command.TenantCommand;
import org.bonitasoft.engine.core.process.instance.api.ProcessInstanceService;
import org.bonitasoft.engine.core.process.instance.model.archive.SAProcessInstance;
import org.bonitasoft.engine.service.TenantServiceAccessor;
import org.slf4j.LoggerFactory;

public class DeleteArchivedProcessInstance extends TenantCommand {

	@Override
	public Serializable execute(Map<String, Serializable> parameters, TenantServiceAccessor serviceAccessor)
			throws SCommandParameterizationException, SCommandExecutionException {
		
		Logger l = Logger.getLogger(DeleteArchivedProcessInstance.class.getName());
		org.slf4j.Logger ls = LoggerFactory.getLogger(DeleteArchivedProcessInstance.class.getName());
		
		Long procId = null;
		Long processesDeleted = (long) 0;
		
		if (parameters.get("processId") != null)
			procId = (Long)parameters.get("processId");
		else return processesDeleted;
		
		ls.info("***Process info received: " + procId);
		l.info("***Process info received: " + procId);
			
		ProcessInstanceService service = serviceAccessor.getProcessInstanceService();
		
		try {
			List <SAProcessInstance> singleProcList = new ArrayList<SAProcessInstance> ();
			singleProcList.add(service.getArchivedProcessInstance(procId));
			l.info("****Got archived Process Instance" + singleProcList.get(0).getProcessDefinitionId()); 
			ls.info("****Got archived Process Instance" + singleProcList.get(0).getProcessDefinitionId());
			processesDeleted = service.deleteParentArchivedProcessInstancesAndElements(singleProcList);
			
		} catch (Exception e) {
			throw new SCommandExecutionException("Error executing command: " + e.getMessage(), e);
		}
		
		return processesDeleted;
	}

}
