package org.bonitasoft.support.command;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.bonitasoft.engine.command.SCommandExecutionException;
import org.bonitasoft.engine.command.SCommandParameterizationException;
import org.bonitasoft.engine.command.TenantCommand;
import org.bonitasoft.engine.core.process.instance.api.ProcessInstanceService;
import org.bonitasoft.engine.core.process.instance.model.archive.SAProcessInstance;
import org.bonitasoft.engine.service.TenantServiceAccessor;

public class DeleteArchivedProcessInstances extends TenantCommand {

	@Override
	public Serializable execute(Map<String, Serializable> parameters, TenantServiceAccessor serviceAccessor)
			throws SCommandParameterizationException, SCommandExecutionException {
		
		List <Long> procs = null;
		Long processesDeleted = (long) 0;
		
		if (parameters.get("processId") != null)
			procs = (ArrayList<Long>)parameters.get("processes");
		else return processesDeleted;
			
		ProcessInstanceService service = serviceAccessor.getProcessInstanceService();
		
		try {
			List <SAProcessInstance> procList = new ArrayList<SAProcessInstance> ();
			for (Long procId : procs) {
				procList.add(service.getArchivedProcessInstance(procId));
			}
			processesDeleted = service.deleteParentArchivedProcessInstancesAndElements(procList);
			
		} catch (Exception e) {
			throw new SCommandExecutionException("Error executing command: " + e.getMessage(), e);
		}
		
		return processesDeleted;
	}

}
